# -------------------------------------------------------------------------------- NOTEBOOK-CELL: CODE
# -*- coding: utf-8 -*-
import dataiku
import pandas as pd, numpy as np
from dataiku import pandasutils as pdu
from process_mining.process_mining import mine_process

# -------------------------------------------------------------------------------- NOTEBOOK-CELL: CODE
# Read recipe inputs
workflow_prepared = dataiku.Dataset("workflow_clean")
workflow_prepared_df = workflow_prepared.get_dataframe()

# -------------------------------------------------------------------------------- NOTEBOOK-CELL: CODE
# Compute recipe outputs
workflow_mined_df, start_end_df, activities_df = mine_process(workflow_prepared_df,
                                                               "case", "activity", "timestamp")

# -------------------------------------------------------------------------------- NOTEBOOK-CELL: CODE
# Write recipe outputs
start_end = dataiku.Dataset("start_end")
start_end.write_with_schema(start_end_df)