The initial folder contains the workflow dataset that was inputted by the user. It can be either in csv or in xes format and its data model is described in [this article](article:12). A folder is used to host this initial dataset to allow for support of both formats.

![Screenshot 2022-06-14 at 12.08.38.png](8MpDlbvhB8WC)

The first recipe parses the input dataset and detects the format of the file using the extension:  **this step will fail if the format is anything other than CSV or XES** . The pm4py library provides a parser to convert an XES file into a dataframe. CSV is handled via the pandas library. Next the workflow is outputted as a Dataiku dataset. There is no reason for this recipe to be run more than once in a given project.

The second recipe incorporates the configuration defined in the [Dataiku application](article:7), creates the [workflow_by_activity](dataset:workflow_by_activity) dataset that will be used in the [webapp](article:8), and applies the following pre-processing steps to the data:

 1. The three mandatory columns (case, activity, and timestamp) are renamed from the source. Additional specified attributes are kept in the dataset, while all others are dropped.
 2. Counts of activity frequency are created and output to the relevant dataset.
 3. Duplicate rows are dropped, and timestamps are parsed. The [three filters](article:13) (excluded activities, time-buffer, self-transition) are applied. The time buffer and self-transition filters are applied iteratively until they no longer filter anything.
 
Finally, the [workflow_clean](dataset:workflow_clean) is created.
